// Capire se conviene considerare quelli effettivamente nelle liste dei vicini o i link effettivi che scaturiscono dalle potenze

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include "cplex.h"

#define MAXNODE 1601
#define DIMGRID 1
#define K 2
#define HIVAL 99999.

#define PMIN .000000001
#define TOLL .0001

#define VAL 1.

	double potte[MAXNODE];
double powe[MAXNODE],posx[MAXNODE], posy[MAXNODE],dist[MAXNODE][MAXNODE];
int n,ngb,idpowe[MAXNODE],come[MAXNODE],superindex;
int veron,nnar,iid[MAXNODE][MAXNODE],inter[MAXNODE];
	double ndst[MAXNODE][MAXNODE];
	int ntodo,seed,nidx[MAXNODE][MAXNODE],ur[MAXNODE][MAXNODE];
	int nn[MAXNODE];
int coveredby[MAXNODE][MAXNODE],ncoveredby[MAXNODE];
char ctype[500000];
int numrows,numerobase,numcols;
CPXENVptr env;
CPXLPptr lp2;
int matind[500000];
double matval[500000];
int matbeg[500000],hit[MAXNODE];
int matcnt[500000],ninter;
double lbc[500000];
double ubc[500000];
double kc[500000];
double rhs[500000];
char sense[500000];

void Formula();
void Formula2();
char Check();
void Printpow2();

char cover(int a, int b)
{
	int i;
	
	for(i=0;i<ncoveredby[b];i++)
		if(coveredby[b][i]==a)
			return 1;
	return 0;
}


double P(int uno, int due)
{
	return pow(sqrt(pow(posx[uno]-posx[due],2)+pow(posy[uno]-posy[due],2)),K);
}

void Crearetehomogeneous()
{
	int i,j,k;
	char rp;

//	printf("Homogeneous network\n");
	for(i=0;i<n;powe[i]=PMIN,i++)
	{
		posx[i]=rand()%(DIMGRID*1000)/1000.;
		posy[i]=rand()%(DIMGRID*1000)/1000.;
	//	printf("%f %f\n",posx[i],posy[i]);
	}
}

void Crearetemultifractal(double beta, int gei)
{
	int i,j,f1,f2,l,ii,jj,kk;
	double prob[10000],prapp[10000],appd,sum,x,y;

//	printf("Multifractal network\n");
	prob[0]=1.;
	l=1;
	for(i=0;i<gei;i++)
	{
		for(j=0;j<l;j++)
		{
			prapp[j*4]=prapp[j*4+1]=prapp[j*4+2]=prapp[j*4+3]=prob[j]*(1.-beta)/4.;
			f1=rand()%4;
			for(f2=rand()%4;f2==f1;f2=rand()%4);
			prapp[j*4+f1]=prapp[j*4+f2]=prob[j]*(1.+beta)/4.;
		}
		for(j=0,l*=4;j<l;j++)
			prob[j]=prapp[j];
	}

	prapp[0]=0.;
	for(j=0;j<l;j++)
		prapp[0]+=prob[j];

	for(j=0;j<n;j++)
	{
		appd=rand()%10000/10000.;
		for(sum=prob[0],i=0;sum<=appd;sum+=prob[++i]);

		appd=DIMGRID;
		jj=pow(4,gei);
		kk=0;
		x=y=0.;
		for(ii=0;ii<gei;ii++)
		{
			if(i>=0 && i<=kk+jj/4)
			{
				kk=kk;
				x=x;
				y=y;
			}
			if(i>=kk+jj/4 && i<=kk+jj*2/4)
			{
				kk=kk+pow(4,gei-1-ii);
				x+=DIMGRID/pow(2,ii+1);
				y=y;
			}
			if(i>=kk+2*jj/4 && i<=kk+jj*3/4)
			{
				kk=kk+2*pow(4,gei-1-ii);
				x+=DIMGRID/pow(2,ii+1);
				y+=DIMGRID/pow(2,ii+1);
			}
			if(i>=kk+3*jj/4 && i<=kk+jj*4/4)
			{
				kk=kk+2*pow(4,gei-1-ii);
				x=x;
				y+=DIMGRID/pow(2,ii+1);
			}
			jj/=4;
		}

		posx[j]=x+(rand()%(int)(DIMGRID*pow(2,gei)*VAL))/VAL;
		posy[j]=y+(rand()%(int)(DIMGRID*pow(2,gei)*VAL))/VAL;
	//	printf("%d: %f %f\n",j,posx[j],posy[j]);
	}

}	

void Crearetemanhattan(int xspace, int yspace)
{
	int i;

//	printf("Manhattan network\n");
	for(i=0;i<n;powe[i]=PMIN,i++)
	{
		if(1==(rand()%2))
		{
			posx[i]=(DIMGRID/((xspace-1)*1.))*(rand()%xspace);
			posy[i]=rand()%(DIMGRID*1000)/1000.;
		}
		else
		{
			posy[i]=(DIMGRID/((yspace-1)*1.))*(rand()%yspace);
			posx[i]=rand()%(DIMGRID*1000)/1000.;	
		}
		//printf("%f %f\n",posx[i],posy[i]);
	}

	/*{ 
		int i,j;
		for(i=0;i<n;i++,printf("\n"))
			for(j=0;j<n;j++)
				printf("%2.2f\t",P(i,j));
	}*/
}

void Assegnapow()
{
	int i,j,k,l,hit[MAXNODE],ind;
	double pi,temp;

	for(i=0;i<n;i++)
			nn[i]=0,idpowe[i]=-14;
	for(i=0;i<n;i++)
	{
		pi=0.;
		for(j=0;j<ngb;j++)
		{
			temp=9999999999999999999999.;
			for(k=0;k<n;k++)
			{
				if(k!=i && (P(i,k)>pi || (P(i,k)==pi && k>hit[j-1])) && P(i,k)<temp)
				{
					temp=P(i,k);
					ind=k;
				}
				//printf("%d %f %f %f\n",i,pi,P(i,k),temp);
			}
			hit[j]=k=ind;
			pi=temp;
		}
		if(pi>powe[i])
		{
			powe[i]=pi;
			idpowe[i]=hit[j-1];
		}
		for(j=0;j<ngb;j++)
		{
			for(k=0;k<nn[i];k++)
				if(nidx[i][k]==hit[j])
					break;
			if(k==nn[i])
				nidx[i][nn[i]++]=hit[j];

			for(k=0;k<nn[hit[j]];k++)
				if(nidx[hit[j]][k]==i)
					break;
			if(k==nn[hit[j]])
				nidx[hit[j]][nn[hit[j]]++]=i;

			if(powe[hit[j]]<P(i,hit[j]))
			{
				powe[hit[j]]=P(i,hit[j]);
				idpowe[hit[j]]=i;
			}
		}
	}
/*
	for(i=0;i<n;i++)
	{
		nn[i]=0;

		for(j=0;j<n;j++)
			if(i!=j && P(i,j)<=powe[i])
				nidx[i][nn[i]++]=j;
	}
*/
/*
	for(i=0;i<n;i++,printf(": %d\n",i-1))
	{
		for(j=0;j<nn[i];j++)
			printf("%d(%f) ",nidx[i][j],P(i,nidx[i][j]));
	}	
*/
//getchar();
}


void CalcolaDist()
{
	int i,j,k;

	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
		{
			if(come[i]<2)
				dist[i][j]=HIVAL;
			else
			{
				if(come[j]<2)
					dist[i][j]=HIVAL;
				else
				{
					if(i!=superindex && j!=superindex)
					{
						// QUI PER NO COORD CARTESIANE => NO GPS
						for(k=0;k<nn[i];k++)
							if(nidx[i][k]==j)
								break;
						if(k<nn[i])
							dist[i][j]=pow(sqrt(((posx[i]-posx[j])*(posx[i]-posx[j]))+((posy[i]-posy[j])*(posy[i]-posy[j]))),K);
						else
							dist[i][j]=HIVAL;
					}
					else
						dist[i][j]=pow(sqrt(((posx[i]-posx[j])*(posx[i]-posx[j]))+((posy[i]-posy[j])*(posy[i]-posy[j]))),K);
				}
			}
		}
}

double DistVera(int i, int j)
{

	return pow(sqrt(((posx[i]-posx[j])*(posx[i]-posx[j]))+((posy[i]-posy[j])*(posy[i]-posy[j]))),K);
	
}


void Leggires()
{
	int i,j;
	char line[128],hole[128];
	FILE *pp;

	pp=fopen("lp.out","r");

	for(i=0;i<n;potte[i]=PMIN,i++)
		for(j=0;j<n;j++)
			ur[i][j]=0;

	//fgets(line,256,pp);
	//fgets(line,256,pp);
	//fgets(line,256,pp);
	//fgets(line,256,pp);
	//fgets(line,256,pp);

	fgets(line,256,pp);

	while(fgets(line,256,pp)!=0)
	{
		if(line[0]=='w')
		{
			sscanf(line,"w_%d  %s\n",&i,hole);	
			
			potte[i]=atof(hole)/VAL;
			//printf("%d %f\n",i,potte[i]);
		}
	}	

	fclose(pp);

	for(i=0;i<n;i++)
		if(come[i]==2)
		for(j=0;j<n;j++)
			if(come[j]==2)
			//if(i!=j && DistVera(i,j)-potte[i]<=.0001 && DistVera(i,j)-potte[j]<=.0001)
			if(i!=j && dist[i][j]-potte[i]<=TOLL && dist[j][i]-potte[j]<=TOLL)
				ur[i][j]=1;//,printf("[%d,%d]",i,j);

	//for(i=0;i<n;i++)
	//	if(come[i]==2 && potte[i]<=0.00001)
	//		printf("RERR %d %d %.20f\n",superindex,i,potte[i]),getchar();
			//else
			//	printf("(%d %d %f %f %f)",i,j,DistVera(i,j),potte[i],potte[j]);
}

void Leggires2()
{
	int i,j;
	double res;
	// LEGGI DA CPLEX

	i=CPXgetstat(env,lp2);

//	if(i!=101)
//		printf("Stato: %d\n",i),getchar();
	  CPXgetmipx(env,lp2,matval,2*nnar,2*nnar+ninter-1);
	    
for(i=0;i<n;i++)
potte[i]=0.;
	    CPXgetmipobjval(env,lp2,&res);
//printf("res: %f\n",res);

	for(i=0;i<ninter;i++)
	{
			potte[inter[i]]=matval[i]/VAL;
		//	printf("%f %f\n",(double)potte[inter[i]],matval[i]);
	}	

	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			ur[i][j]=0;
	for(i=0;i<ninter;i++)
		for(j=0;j<ninter;j++)
			//if(i!=j && DistVera(i,j)-potte[i]<=.0001 && DistVera(i,j)-potte[j]<=.0001)
			if(i!=j && dist[inter[i]][inter[j]]-potte[inter[i]]<=TOLL && dist[inter[j]][inter[i]]-potte[inter[j]]<=TOLL)
				ur[inter[i]][inter[j]]=1;//,printf("[%d,%d]",i,j);
}

char notinhit(int k, int j)
{
	int i;
	for(i=0;i<j;i++)
		if(hit[i]==k)
			return 0;
		
	return 1;
}

void Assegnapow2()
{
	int i,j,k,l,ii,jj,ind,ind2,cont;
	double pi,temp;

	//getchar();
	for(i=0;i<n;i++)
	{
		ncoveredby[i]=0;
			nn[i]=0,idpowe[i]=-14;
	}

	for(i=0;i<n;i++)
	{
		superindex=i;
//		printf("Di interesse: %d\n",i);

		for(ii=0;ii<n;ii++)
				come[ii]=-14;
		
		//Metto a 1 tutti i miei vicini

		for(j=0;j<nn[i];j++)
		{
			come[nidx[i][j]]=1;
			coveredby[nidx[i][j]][ncoveredby[nidx[i][j]]++]=i;
		}

		come[i]=2;

		pi=-1.;


		cont=0;
		for(j=0;j<ngb || cont;j++)
		{

			cont=0;
			temp=9999999999999999999999.;

			for(k=0;k<n;k++)
			{
				if(k!=i && (DistVera(i,k)>pi || (DistVera(i,k) == pi && notinhit(k,j))) && DistVera(i,k)<temp)
				{
					temp=DistVera(i,k);
					ind=k;
				}
			}

			hit[j]=ind;
			pi=DistVera(i,ind);
			
			//printf("%d %d %d\n",i,j,ind);
			// Preparo il grafo locale
//			printf("Inserisco %d\n",ind);
			for(jj=0;jj<nn[ind];jj++)
			{
				if(!cover(ind,nidx[ind][jj]))
					coveredby[nidx[ind][jj]][ncoveredby[nidx[ind][jj]]++]=ind;
				if(come[nidx[ind][jj]]<0)
						come[nidx[ind][jj]]=1;
			}
			come[ind]=2;

			if(j>=ngb-1 && DistVera(i,hit[j-1]) == DistVera(i,ind))
			{
//				printf("%d %d\n",hit[j-1], ind);
				cont=1;
			}
		}

			CalcolaDist();
//printf("\n");
//			for(j=0;j<n;j++)
//			{	
//				int k;
//				printf("%d: (",come[j]);
//				for(k=0;k<nn[j];k++)
//					printf("%d ",nidx[j][k]);
//				printf(")\n");
//			}


				Formula2();
		// Calcolo powers

		CPXmipopt(env,lp2);
		Leggires2();

		// Comunico powers e aggiusto vicini 

		for(j=0;j<ninter;j++)
			{
				for(k=l=0;k<nn[inter[j]];k++)
					if(come[nidx[inter[j]][k]]==1 && cover(inter[j],nidx[inter[j]][k]))
					{
						nidx[inter[j]][l++]=nidx[inter[j]][k];
					}
					else
					{
						if(ur[inter[j]][nidx[inter[j]][k]]==1)
						{
							nidx[inter[j]][l++]=nidx[inter[j]][k];
							ur[inter[j]][nidx[inter[j]][k]]++;
						}
					}
				for(k=0;k<n;k++)
					if(ur[inter[j]][k]==1)
					{
						nidx[inter[j]][l++]=k;
					}
				nn[inter[j]]=l;
			}		
		Printpow2();

			CPXfreeprob(env,&lp2);
	}

}

void Printpow2()
{
	int i,j,k,max;
	double sum;

	for(i=0;i<n;i++)
		come[i]=2;
	veron=n;
	
	CalcolaDist();

	for(sum=0.,max=0,i=j=0;i<n;j+=nn[i],sum+=powe[i],i++)
	{
		if(nn[i]>max)
			max=nn[i];
		powe[i]=0.;
		for(k=0;k<nn[i];k++)
			if(dist[i][nidx[i][k]]>powe[i])
				powe[i]=dist[i][nidx[i][k]];
		//printf("%d %f %d\n",i,powe[i],nn[i]);
	}
}

void Printpow()
{
	int i,j,k,max;
	double sum;

	for(i=0;i<n;i++)
		come[i]=2;
	veron=n;
	
	CalcolaDist();

	for(sum=0.,max=0,i=j=0;i<n;j+=nn[i],sum+=powe[i],i++)
	{
		if(nn[i]>max)
			max=nn[i];
		powe[i]=0.;
		for(k=0;k<nn[i];k++)
			if(dist[i][nidx[i][k]]>powe[i])
				powe[i]=dist[i][nidx[i][k]];
		//printf("%d %f %d\n",i,powe[i],nn[i]);
	}

	printf("Total power: %f\t Average degree: %f\t Max degree: %d ",sum,j*1./n,max);
			printf("Risultato: %d \n",i=Check());//,getchar();
}


char Calapow()
{
	int i,j,k,l,jj;
	char trov,ret,trov2;
	double pp;

//printf("Calo\n");	

	ret=0;
	for(k=0;k<n;k++)
	{
		trov=0;
		if(nn[k]>1) 

		// Controllo di essere, tra i miei vicini che condividono il mio
		// vicino+lontano, quello che spara piu' lontano e controllo che 
		// tra i vicini dei miei vicini vi sia qualcuno collegato con il
		// mio vicino+lontano
 		 for(i=0;i<nn[k];i++)
 		 {
			// Se ho vicino che ha come vicino+lontano il mio stesso 
			// vicino+lontano ma spara piu' distante per raggiungerlo
			// allora non sono intitolato a calare
	 		if(idpowe[nidx[k][i]]==idpowe[k] && powe[nidx[k][i]]>powe[k])
			{
				break;
			}
			// Se tra i vicini del vicino con le caratteristiche sopra
			// ve ne e' almeno uno connesso a me allora proseguo analisi
			/*for(jj=trov2=0;jj<nn[nidx[k][i]];jj++)
				if(nidx[nidx[k][i]][jj]==k)
				{
						trov2=1;
						break;
				}*/
			// Se tra i vicini del vicino con le caratteristiche sopra
			// ve ne e' uno corrispondente al mio vicino+lontano allora
			// sono intitolato a calare
			if(!trov && trov2)
				for(j=0;j<nn[nidx[k][i]];j++)
					if(nidx[nidx[k][i]][j]==idpowe[k])
					{	
						trov=1;
						break;
					}
	  	 }		

		
		if((i==nn[k] && trov))
		{
			pp=0.;
			l=-14;
			
			for(j=0;j<nn[k];j++)
			{
				// Cancello il mio vicino+lontano
				if(nidx[k][j]==idpowe[k])
				{
					nidx[k][j]=nidx[k][nn[k]-1];
					ndst[k][j]=ndst[k][nn[k]-1];
					nn[k]--;

					// Provvedo a farmi cancellare dalla sua lista di vicini
					// ed eventualmente aggiorno la sua potenza massima
					for(jj=0;jj<nn[idpowe[k]];jj++)
						if(nidx[idpowe[k]][jj]==k)
						{
							nidx[idpowe[k]][jj]=nidx[idpowe[k]][nn[idpowe[k]]-1];
							ndst[idpowe[k]][jj]=ndst[idpowe[k]][nn[idpowe[k]]-1];
							nn[idpowe[k]]--;
							if(idpowe[idpowe[k]]==k)
							{
								powe[idpowe[k]]=0.;
								idpowe[idpowe[k]]=-14;
								for(jj=0;jj<nn[idpowe[k]];jj++)
									if(P(nidx[idpowe[k]][jj],idpowe[k])>powe[idpowe[k]])
									{
										powe[idpowe[k]]=P(nidx[idpowe[k]][jj],idpowe[k]);
										idpowe[idpowe[k]]=nidx[idpowe[k]][jj];
									}
							}
						}
					break;
				}
			}

			// Risetto potenza massima
			for(j=0;j<nn[k];j++)
			{
				if(P(k,nidx[k][j])>pp)
				{
					pp=P(k,nidx[k][j]);
					l=nidx[k][j];
				}
			}

			powe[k]=pp;
			idpowe[k]=l;
			ret=1;
		}
	}

	return ret;
}

char Check()
{
	int i,j,todo[MAXNODE],done[MAXNODE],ndone,app,oldntodo,k;
	char nuovo;

	for(i=0;i<n;i++)
		done[i]=0;
	ntodo=ndone=1;

	for(i=0;;i++)
		if(come[i]==2)
		{
			done[i]=1;
			todo[0]=i;
			break;
		}
	nuovo=1;
	oldntodo=0;
	while(nuovo)
	{
		nuovo=0;
		app=ntodo;
		for(i=oldntodo;i<ntodo;i++)
			for(j=0;j<nn[todo[i]];j++)
				if(!done[nidx[todo[i]][j]] && come[nidx[todo[i]][j]]==2)
				{
					done[nidx[todo[i]][j]]=1;
					todo[ntodo++]=nidx[todo[i]][j];
					nuovo=1;
				}
		oldntodo=app;
	}

	if(ntodo==veron)
		return 1;
	else 
		return 0;
}

void Formula()
{
	int i,j,jj,k,l,ii,s;
	double act,old;

	FILE *fil;

	fil=fopen("lp.lp","w");
	fprintf(fil,"Min: ");
	for(i=veron=0;i<n;i++)		
		if(come[i]==2)
		{
				fprintf(fil," + w_%d",i);
				veron++;
				s=i;
		}
	fprintf(fil,";\n");
	
	for(i=0;i<n;i++)
		if(come[i]==2)
	{
		for(j=0;j<n;j++)
			if(i!=j && come[j]==2)
			{
				fprintf(fil," t_%d_%d <= %d u_%d_%d ;\n",i,j,veron-1,i,j);
			}
	}

	for(i=0;i<n;i++)
		if(come[i]==2)
			//if(i!=superindex)
			{
				ii=-14;
				for(j=0;j<nn[i];j++)
					if(come[nidx[i][j]]<2)
					{
						//printf("Uno e' trovato %d %d %f\n",i,nidx[i][j],DistVera(i,nidx[i][j]));
						if(ii==-14 || DistVera(i,nidx[i][j])>DistVera(i,nidx[i][ii]))
							ii=j;
					}
				if(ii!=-14)
					fprintf(fil," w_%d >= %.20f; \n",i,DistVera(i,nidx[i][ii])*VAL);
			}

	for(i=0;i<n;i++)
		if(come[i]==2)
	{
		for(j=0;j<n;j++)
			if(i!=j && come[j]==2)
			{
				fprintf(fil,"+ t_%d_%d ",i,j);
			}
		for(j=0;j<n;j++)
			if(i!=j && come[j]==2)
			{
				fprintf(fil,"- t_%d_%d ",j,i);
			}
		fprintf(fil,"= %d ;\n",(i==s)?veron-1:-1);
	}

	for(i=0;i<n;i++)
		if(come[i]==2)
		for(jj=0;jj<n;jj++)
			if(i!=jj && come[jj]==2)
				fprintf(fil,"%.20f u_%d_%d <= w_%d ;\n",dist[i][jj]*VAL,i,jj,i);

	for(i=0;i<n;i++)
		if(come[i]==2)
		 for(jj=i+1;jj<n;jj++)
			 if(come[jj]==2)
				fprintf(fil," u_%d_%d = u_%d_%d ;\n",i,jj,jj,i);

	// int
	fprintf(fil,"int ");
	for(i=0;i<n;i++)
		if(come[i]==2)
		 for(jj=0;jj<n;jj++)
			if(i!=jj && come[jj]==2)
				fprintf(fil,"u_%d_%d ",i,jj);
	fprintf(fil,";\n");				

	fclose(fil);

	return;
}

void Formula2()
{
	int i,j,jj,k,l,ii,s,iii;
	double act,old;
	int uno, due;

	 lp2=CPXcreateprob(env,&i,"Monte14");

  // COLONNE

  // u variables  
  for(i=k=ninter=0;i<n;i++)
	  if(come[i]==2)
		{
		  inter[ninter++]=i;
			for(j=0;j<n;j++)
				if(j!=i && come[j]==2)
				{
					iid[i][j]=k;
					ctype[k]='B'; // C
					kc[k]=0.;
					lbc[k]=0.;
					ubc[k]=1.;
					k++;
				}
		}
	nnar=k;

//	printf("INTER: \n");
//	for(i=0;i<ninter;i++,printf("\n"))
//		for(j=0;j<ninter;j++)
//			printf("%.0f ",dist[inter[i]][inter[j]]);
//	printf("\n ");
	
  // t variable
	for(i=0;i<ninter;i++)
		{
			for(j=0;j<ninter;j++)
				if(inter[j]!=inter[i])
				{
					ctype[k]='C'; // C
					kc[k]=0.;
					lbc[k]=0.;
					ubc[k]=CPX_INFBOUND;
					k++;
				}
		}

	//if(k!=2*nnar)
	//	printf("Mistake\n");

	// w variables
	  for(i=0;i<ninter;i++)
		{
			ctype[k]='C'; // C
			kc[k]=1.;
			lbc[k]=0.;
			ubc[k]=CPX_INFBOUND;
			k++;
		}

  
  numcols=k;

  i=CPXcopylp(env,lp2,numcols,0,CPX_MIN,kc,rhs,sense,matbeg,matcnt,matind,matval,lbc,ubc,NULL);
  //printf("Faccio %d\n",i);getchar();
  i=CPXcopyctype(env,lp2,ctype);
  //printf("Faccio %d\n",i);getchar();
  //i=CPXmipopt(env,lp2);
  //CPXgetmipobjval(env,lp2,&old);
  //printf("Faccio %d %f\n",i,old);getchar();

  // Righe

  //for(i=0;i<ninter;i++)
	//  printf("%d ",inter[i]);getchar();

  for(i=0;i<ninter;i++)
		for(jj=i+1;jj<ninter;jj++)
			{
				if(iid[inter[i]][inter[jj]]<iid[inter[jj]][inter[i]])
				{
					uno=iid[inter[i]][inter[jj]];
					due=iid[inter[jj]][inter[i]];
				}
				else
				{
					due=iid[inter[i]][inter[jj]];
					uno=iid[inter[jj]][inter[i]];
				}

				//printf("u_%d_%d - u_%d_%d = 0 \n",inter[i],inter[jj],inter[jj],inter[i]);
				matbeg[k=0]=0;
				matind[k]=uno;
				matval[k]=1.;
				k++;
				matind[k]=due;
				matval[k]=-1.;
				k++;
				rhs[0]=0.;
				sense[0]='E';
				iii=CPXaddrows(env,lp2,0,1,k,rhs,sense,matbeg,matind,matval,NULL,NULL);
				if(iii!=0)
				printf("Faccio %d\n",iii),getchar();
			}

	for(i=0;i<ninter;i++)
		for(jj=0;jj<ninter;jj++)
			if(i!=jj )
			{
				matbeg[k=0]=0;
				matind[k]=iid[inter[i]][inter[jj]];
				matval[k]=(dist[inter[i]][inter[jj]])*VAL;
				k++;
				matind[k]=2*nnar+i;
				matval[k]=-1.;
				k++;
				rhs[0]=0.;
				sense[0]='L';
				//printf("%f u_%d_%d - w_%d <= 0\n",(dist[inter[i]][inter[jj]])*VAL,inter[i],inter[jj],inter[i]);
				iii=CPXaddrows(env,lp2,0,1,k,rhs,sense,matbeg,matind,matval,NULL,NULL);
				if(iii!=0)
				printf("Faccio %d\n",iii),getchar();
			}

	for(i=0;i<ninter;i++)
	{
		for(j=0;j<ninter;j++)
			if(i!=j)
			{
				matbeg[k=0]=0;
				matind[k]=iid[inter[i]][inter[j]];
				matval[k]=(double)(-ninter+1);
				k++;
				matind[k]=nnar+iid[inter[i]][inter[j]];;
				matval[k]=1.;
				k++;
				rhs[0]=0.;
				sense[0]='L';

			//	printf("%d u_%d_%d + t_%d_%d <= 0\n",-ninter,inter[i],inter[j],inter[i],inter[j]);

				iii=CPXaddrows(env,lp2,0,1,k,rhs,sense,matbeg,matind,matval,NULL,NULL);
				if(iii!=0)
				printf("Faccio %d\n",iii),getchar();
			}
	}

		for(i=0;i<ninter;i++)
			{
			//printf("%d\n",i);
				ii=-14;
				for(j=0;j<nn[inter[i]];j++)
					if(come[nidx[inter[i]][j]]==1 && cover(inter[i],nidx[inter[i]][j]))
					{
						if(ii==-14 || DistVera(inter[i],nidx[inter[i]][j])>DistVera(inter[i],nidx[inter[i]][ii]))
							ii=j;
					}
					
				if(ii!=-14)
				{
					matbeg[k=0]=0;
					matind[k]=2*nnar+i;
					matval[k]=1.;
					k++;
					rhs[0]=DistVera(inter[i],nidx[inter[i]][ii])*VAL;
					sense[0]='G';
					iii=CPXaddrows(env,lp2,0,1,k,rhs,sense,matbeg,matind,matval,NULL,NULL);
					
					//printf("Faccio %f\n",rhs[0]),getchar();
				}
			}

	for(i=0;i<ninter;i++)
	{
			matbeg[k=0]=0;
			for(j=0;j<i;j++)
			{
				matind[k]=nnar+iid[inter[j]][inter[i]];
			//	printf("- t_%d_%d ",inter[j],inter[i]);
				matval[k]=-1.;
				k++;
			}
			for(j=0;j<ninter;j++)
			if(i!=j)
			{
				matind[k]=nnar+iid[inter[i]][inter[j]];
			//	printf("+ t_%d_%d ",inter[i],inter[j]);
				//printf("%d ",matind[k]);	
				matval[k]=1.;
				k++;
			}
			for(j=i+1;j<ninter;j++)
			{
				matind[k]=nnar+iid[inter[j]][inter[i]];
			//	printf("- t_%d_%d ",inter[j],inter[i]);
				//printf("%d ",matind[k]);
				matval[k]=-1.;
				k++;
			}
//printf("\n");
			rhs[0]=(double)((i==0)?ninter-1:-1);
			//printf("= %f\n",rhs[0]);
			sense[0]='E';
			iii=CPXaddrows(env,lp2,0,1,k,rhs,sense,matbeg,matind,matval,NULL,NULL);
			if(iii!=0)
			printf("Faccio %d\n",iii),getchar();
	}

	return;
}



int main(int argc, char* argv[])
{
	int i,j,k,iter;
	char itera;

	n=atoi(argv[1]);
	srand(seed=atoi(argv[4]));
	ngb=atoi(argv[3]);

	 env=CPXopenCPLEX(&i);
	 i=CPXsetintparam(env, CPX_PARAM_SCRIND, 0);
	printf("%d - %d\n",n,ngb);

			if(!strcmp("HO",argv[2]))
			printf("Honogeneous networks\n");
		
		if(!strcmp("MA",argv[2]))
			printf("Manhattana networks\n");

		if(!strcmp("MU",argv[2]))
			printf("Multifractal networks\n");

	for(iter=0;iter<50;iter++)
	{
		if(!strcmp("HO",argv[2]))
			Crearetehomogeneous();
		
		if(!strcmp("MA",argv[2]))
			Crearetemanhattan(7,7);

		if(!strcmp("MU",argv[2]))
			Crearetemultifractal(.4,5);

		/*
		{
			int i,j,k,l;
			for(i=0;i<n;i++)
				for(j=0;j<n;j++)
					if(i!=j)
						for(k=0;k<n;k++)
							if(k!=j && k!=i)
									if(fabs(DistVera(i,j)-DistVera(i,k))<TOLL)
										printf("%d - %d %d, %f %f\n",i,j,k,DistVera(i,j),DistVera(i,k));
		printf("Fine test\n");
		}
		*/

		//if(strcmp(argv[5],"1"))
		printf("\n Siemens:\n");
		Assegnapow();
		printf("A ");Printpow();
		//else
		printf("Montemanni:\n");
		Assegnapow2();	
		printf("B ");Printpow();

/*exit(1);
		if(i)
		{
			for(k=0,itera=1;itera;k++)
				itera=Calapow();
			printf("Eseguite %d iterazioni di cala\n",k);
	
			Printpow();
		
			printf("Risultato: %d \n",i=Check());//,getchar();
			if(!i)
				printf("Brutta storia\n"),getchar();
		}
*/
	}
	CPXcloseCPLEX(&env);
}
	